package com.example.demo.signapi.client.api;

import com.example.demo.signapi.client.invoker.ApiException;
import com.example.demo.signapi.client.invoker.ApiClient;
import com.example.demo.signapi.client.invoker.ApiResponse;
import com.example.demo.signapi.client.invoker.Configuration;
import com.example.demo.signapi.client.invoker.Pair;

import javax.ws.rs.core.GenericType;

import java.io.File;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class ArchiveDocumentApi {
  private ApiClient apiClient;

  public ArchiveDocumentApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ArchiveDocumentApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }
  /**
   * Get archived document
   * Get a document from Signicat&#39;s document archive
   * @param archiveId The ID of the document stored in Signicat&#39;s document archive. (required)
   * @return File
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The archived document was successfully retrieved. </td><td>  -  </td></tr>
     </table>
   */
  public File getArchiveDocument(String archiveId) throws ApiException {
    return getArchiveDocumentWithHttpInfo(archiveId).getData();
  }

  /**
   * Get archived document
   * Get a document from Signicat&#39;s document archive
   * @param archiveId The ID of the document stored in Signicat&#39;s document archive. (required)
   * @return ApiResponse&lt;File&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The archived document was successfully retrieved. </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<File> getArchiveDocumentWithHttpInfo(String archiveId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'archiveId' is set
    if (archiveId == null) {
      throw new ApiException(400, "Missing the required parameter 'archiveId' when calling getArchiveDocument");
    }
    
    // create path and map variables
    String localVarPath = "/archive-documents/{archiveId}"
      .replaceAll("\\{" + "archiveId" + "\\}", apiClient.escapeString(archiveId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json", "application/pdf", "text/plain"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<File> localVarReturnType = new GenericType<File>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
