package com.example.demo.signapi.client.api;

import com.example.demo.signapi.client.invoker.ApiException;
import com.example.demo.signapi.client.invoker.ApiClient;
import com.example.demo.signapi.client.invoker.ApiResponse;
import com.example.demo.signapi.client.invoker.Configuration;
import com.example.demo.signapi.client.invoker.Pair;

import javax.ws.rs.core.GenericType;

import com.example.demo.signapi.client.model.ClientProblem;
import com.example.demo.signapi.client.model.DocumentRefId;
import java.io.File;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class DocumentApi {
  private ApiClient apiClient;

  public DocumentApi() {
    this(Configuration.getDefaultApiClient());
  }

  public DocumentApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }
  /**
   * Delete document
   * Deletes a document from Signicat&#39;s document storage backend
   * @param documentId  (required)
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 204 </td><td> The document was successfully deleted </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is invalid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public void deleteFileOnSds(String documentId) throws ApiException {
    deleteFileOnSdsWithHttpInfo(documentId);
  }

  /**
   * Delete document
   * Deletes a document from Signicat&#39;s document storage backend
   * @param documentId  (required)
   * @return ApiResponse&lt;Void&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 204 </td><td> The document was successfully deleted </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is invalid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<Void> deleteFileOnSdsWithHttpInfo(String documentId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'documentId' is set
    if (documentId == null) {
      throw new ApiException(400, "Missing the required parameter 'documentId' when calling deleteFileOnSds");
    }
    
    // create path and map variables
    String localVarPath = "/documents/{documentId}"
      .replaceAll("\\{" + "documentId" + "\\}", apiClient.escapeString(documentId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    
    return apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Get document
   * Get a document from Signicat&#39;s document storage backend
   * @param documentId  (required)
   * @return File
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is invalid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public File getSdsDocument(String documentId) throws ApiException {
    return getSdsDocumentWithHttpInfo(documentId).getData();
  }

  /**
   * Get document
   * Get a document from Signicat&#39;s document storage backend
   * @param documentId  (required)
   * @return ApiResponse&lt;File&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is invalid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<File> getSdsDocumentWithHttpInfo(String documentId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'documentId' is set
    if (documentId == null) {
      throw new ApiException(400, "Missing the required parameter 'documentId' when calling getSdsDocument");
    }
    
    // create path and map variables
    String localVarPath = "/documents/{documentId}"
      .replaceAll("\\{" + "documentId" + "\\}", apiClient.escapeString(documentId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json", "application/pdf", "text/plain"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<File> localVarReturnType = new GenericType<File>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Upload session document
   * Upload a document to Signicat&#39;s session data storage
   * @param body  (optional)
   * @return DocumentRefId
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 201 </td><td> The session document was succesfully uploaded </td><td>  -  </td></tr>
       <tr><td> 411 </td><td> The uploaded document cannot be empty </td><td>  -  </td></tr>
     </table>
   */
  public DocumentRefId uploadFileToSds(File body) throws ApiException {
    return uploadFileToSdsWithHttpInfo(body).getData();
  }

  /**
   * Upload session document
   * Upload a document to Signicat&#39;s session data storage
   * @param body  (optional)
   * @return ApiResponse&lt;DocumentRefId&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 201 </td><td> The session document was succesfully uploaded </td><td>  -  </td></tr>
       <tr><td> 411 </td><td> The uploaded document cannot be empty </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<DocumentRefId> uploadFileToSdsWithHttpInfo(File body) throws ApiException {
    Object localVarPostBody = body;
    
    // create path and map variables
    String localVarPath = "/documents";

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/pdf", "text/plain"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<DocumentRefId> localVarReturnType = new GenericType<DocumentRefId>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
