package com.example.demo.signapi.client.api;

import com.example.demo.signapi.client.invoker.ApiException;
import com.example.demo.signapi.client.invoker.ApiClient;
import com.example.demo.signapi.client.invoker.ApiResponse;
import com.example.demo.signapi.client.invoker.Configuration;
import com.example.demo.signapi.client.invoker.Pair;

import javax.ws.rs.core.GenericType;

import com.example.demo.signapi.client.model.ClientProblem;
import com.example.demo.signapi.client.model.Event;
import java.io.File;
import com.example.demo.signapi.client.model.PackagingTaskStatusInfo;
import com.example.demo.signapi.client.model.SigningOrder;
import com.example.demo.signapi.client.model.SigningOrderRefId;
import com.example.demo.signapi.client.model.TaskStatusInfo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class SigningOrderApi {
  private ApiClient apiClient;

  public SigningOrderApi() {
    this(Configuration.getDefaultApiClient());
  }

  public SigningOrderApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }
  /**
   * Create signing order
   * Creates a new signing order
   * @param signingOrder  (required)
   * @return SigningOrderRefId
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 201 </td><td> The signing order was successfully created </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The signing order is not valid </td><td>  -  </td></tr>
     </table>
   */
  public SigningOrderRefId createRequest(SigningOrder signingOrder) throws ApiException {
    return createRequestWithHttpInfo(signingOrder).getData();
  }

  /**
   * Create signing order
   * Creates a new signing order
   * @param signingOrder  (required)
   * @return ApiResponse&lt;SigningOrderRefId&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 201 </td><td> The signing order was successfully created </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The signing order is not valid </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<SigningOrderRefId> createRequestWithHttpInfo(SigningOrder signingOrder) throws ApiException {
    Object localVarPostBody = signingOrder;
    
    // verify the required parameter 'signingOrder' is set
    if (signingOrder == null) {
      throw new ApiException(400, "Missing the required parameter 'signingOrder' when calling createRequest");
    }
    
    // create path and map variables
    String localVarPath = "/orders";

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<SigningOrderRefId> localVarReturnType = new GenericType<SigningOrderRefId>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Delete signing order
   * Deletes an exisiting signing order
   * @param orderId  (required)
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 204 </td><td> The signing order was successfully deleted </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The signing order id is invalid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The signing order was not found </td><td>  -  </td></tr>
     </table>
   */
  public void deleteSigningOrder(String orderId) throws ApiException {
    deleteSigningOrderWithHttpInfo(orderId);
  }

  /**
   * Delete signing order
   * Deletes an exisiting signing order
   * @param orderId  (required)
   * @return ApiResponse&lt;Void&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 204 </td><td> The signing order was successfully deleted </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The signing order id is invalid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The signing order was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<Void> deleteSigningOrderWithHttpInfo(String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling deleteSigningOrder");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}"
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    
    return apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Get generated document
   * Get a generated document from Signicat&#39;s document storage
   * @param documentId  (required)
   * @param taskId  (required)
   * @param orderId  (required)
   * @return File
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The generated document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public File getGeneratedDocument(String documentId, String taskId, String orderId) throws ApiException {
    return getGeneratedDocumentWithHttpInfo(documentId, taskId, orderId).getData();
  }

  /**
   * Get generated document
   * Get a generated document from Signicat&#39;s document storage
   * @param documentId  (required)
   * @param taskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;File&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The generated document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<File> getGeneratedDocumentWithHttpInfo(String documentId, String taskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'documentId' is set
    if (documentId == null) {
      throw new ApiException(400, "Missing the required parameter 'documentId' when calling getGeneratedDocument");
    }
    
    // verify the required parameter 'taskId' is set
    if (taskId == null) {
      throw new ApiException(400, "Missing the required parameter 'taskId' when calling getGeneratedDocument");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getGeneratedDocument");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/tasks/{taskId}/documents/{documentId}/generated"
      .replaceAll("\\{" + "documentId" + "\\}", apiClient.escapeString(documentId.toString()))
      .replaceAll("\\{" + "taskId" + "\\}", apiClient.escapeString(taskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json", "application/pdf"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<File> localVarReturnType = new GenericType<File>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Get original document
   * Get an original document from Signicat&#39;s document storage
   * @param documentId  (required)
   * @param taskId  (required)
   * @param orderId  (required)
   * @return File
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The original document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public File getOriginalDocument(String documentId, String taskId, String orderId) throws ApiException {
    return getOriginalDocumentWithHttpInfo(documentId, taskId, orderId).getData();
  }

  /**
   * Get original document
   * Get an original document from Signicat&#39;s document storage
   * @param documentId  (required)
   * @param taskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;File&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The original document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<File> getOriginalDocumentWithHttpInfo(String documentId, String taskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'documentId' is set
    if (documentId == null) {
      throw new ApiException(400, "Missing the required parameter 'documentId' when calling getOriginalDocument");
    }
    
    // verify the required parameter 'taskId' is set
    if (taskId == null) {
      throw new ApiException(400, "Missing the required parameter 'taskId' when calling getOriginalDocument");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getOriginalDocument");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/tasks/{taskId}/documents/{documentId}/original"
      .replaceAll("\\{" + "documentId" + "\\}", apiClient.escapeString(documentId.toString()))
      .replaceAll("\\{" + "taskId" + "\\}", apiClient.escapeString(taskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json", "application/pdf", "text/plain"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<File> localVarReturnType = new GenericType<File>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Get signed document
   * Get a signed document from Signicat&#39;s document storage
   * @param documentId  (required)
   * @param taskId  (required)
   * @param orderId  (required)
   * @return File
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The signed document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 303 </td><td> The signed document is stored in document archive </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   * The signature result
   * @see <a href="https://developer.signicat.com/documentation/signing/get-started-with-signing/the-signature-result">Get signed document Documentation</a>
   */
  public File getResultDocument(String documentId, String taskId, String orderId) throws ApiException {
    return getResultDocumentWithHttpInfo(documentId, taskId, orderId).getData();
  }

  /**
   * Get signed document
   * Get a signed document from Signicat&#39;s document storage
   * @param documentId  (required)
   * @param taskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;File&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The signed document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 303 </td><td> The signed document is stored in document archive </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The documentID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The documentID was not found </td><td>  -  </td></tr>
     </table>
   * The signature result
   * @see <a href="https://developer.signicat.com/documentation/signing/get-started-with-signing/the-signature-result">Get signed document Documentation</a>
   */
  public ApiResponse<File> getResultDocumentWithHttpInfo(String documentId, String taskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'documentId' is set
    if (documentId == null) {
      throw new ApiException(400, "Missing the required parameter 'documentId' when calling getResultDocument");
    }
    
    // verify the required parameter 'taskId' is set
    if (taskId == null) {
      throw new ApiException(400, "Missing the required parameter 'taskId' when calling getResultDocument");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getResultDocument");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/tasks/{taskId}/documents/{documentId}/result"
      .replaceAll("\\{" + "documentId" + "\\}", apiClient.escapeString(documentId.toString()))
      .replaceAll("\\{" + "taskId" + "\\}", apiClient.escapeString(taskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json", "application/pdf", "text/plain"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<File> localVarReturnType = new GenericType<File>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Get packaging task result document
   * Get the result document of a packaging task
   * @param packagingTaskId  (required)
   * @param orderId  (required)
   * @return File
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The packaging task result document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 303 </td><td> The document can be downloaded in another endpoint specified by the Location header </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The packagingTaskID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The document was not found </td><td>  -  </td></tr>
     </table>
   */
  public File getResultDocument1(String packagingTaskId, String orderId) throws ApiException {
    return getResultDocument1WithHttpInfo(packagingTaskId, orderId).getData();
  }

  /**
   * Get packaging task result document
   * Get the result document of a packaging task
   * @param packagingTaskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;File&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The packaging task result document was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 303 </td><td> The document can be downloaded in another endpoint specified by the Location header </td><td>  -  </td></tr>
       <tr><td> 400 </td><td> The packagingTaskID is not valid </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The document was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<File> getResultDocument1WithHttpInfo(String packagingTaskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'packagingTaskId' is set
    if (packagingTaskId == null) {
      throw new ApiException(400, "Missing the required parameter 'packagingTaskId' when calling getResultDocument1");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getResultDocument1");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/packaging-tasks/{packagingTaskId}/result"
      .replaceAll("\\{" + "packagingTaskId" + "\\}", apiClient.escapeString(packagingTaskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json", "application/pdf", "application/x-pades"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<File> localVarReturnType = new GenericType<File>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Get task status
   * Get signing order task current status
   * @param taskId  (required)
   * @param orderId  (required)
   * @return TaskStatusInfo
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The task status was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The task was not found </td><td>  -  </td></tr>
     </table>
   */
  public TaskStatusInfo getStatus(String taskId, String orderId) throws ApiException {
    return getStatusWithHttpInfo(taskId, orderId).getData();
  }

  /**
   * Get task status
   * Get signing order task current status
   * @param taskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;TaskStatusInfo&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The task status was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The task was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<TaskStatusInfo> getStatusWithHttpInfo(String taskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'taskId' is set
    if (taskId == null) {
      throw new ApiException(400, "Missing the required parameter 'taskId' when calling getStatus");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getStatus");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/tasks/{taskId}/status"
      .replaceAll("\\{" + "taskId" + "\\}", apiClient.escapeString(taskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<TaskStatusInfo> localVarReturnType = new GenericType<TaskStatusInfo>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Get packaging task status
   * Get the status of a signing order packaging task
   * @param packagingTaskId  (required)
   * @param orderId  (required)
   * @return PackagingTaskStatusInfo
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The packaging task status was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The packagingTaskID was not found </td><td>  -  </td></tr>
     </table>
   */
  public PackagingTaskStatusInfo getStatus1(String packagingTaskId, String orderId) throws ApiException {
    return getStatus1WithHttpInfo(packagingTaskId, orderId).getData();
  }

  /**
   * Get packaging task status
   * Get the status of a signing order packaging task
   * @param packagingTaskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;PackagingTaskStatusInfo&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The packaging task status was successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The packagingTaskID was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<PackagingTaskStatusInfo> getStatus1WithHttpInfo(String packagingTaskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'packagingTaskId' is set
    if (packagingTaskId == null) {
      throw new ApiException(400, "Missing the required parameter 'packagingTaskId' when calling getStatus1");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getStatus1");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/packaging-tasks/{packagingTaskId}/status"
      .replaceAll("\\{" + "packagingTaskId" + "\\}", apiClient.escapeString(packagingTaskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<PackagingTaskStatusInfo> localVarReturnType = new GenericType<PackagingTaskStatusInfo>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Get a list of task events
   * Get a list of events that have occurred on a task
   * @param taskId  (required)
   * @param orderId  (required)
   * @return Event
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The task&#39;s events were successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The taskID was not found </td><td>  -  </td></tr>
     </table>
   */
  public Event getTaskEvents(String taskId, String orderId) throws ApiException {
    return getTaskEventsWithHttpInfo(taskId, orderId).getData();
  }

  /**
   * Get a list of task events
   * Get a list of events that have occurred on a task
   * @param taskId  (required)
   * @param orderId  (required)
   * @return ApiResponse&lt;Event&gt;
   * @throws ApiException if fails to make API call
   * @http.response.details
     <table summary="Response Details" border="1">
       <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
       <tr><td> 200 </td><td> The task&#39;s events were successfully retrieved </td><td>  -  </td></tr>
       <tr><td> 404 </td><td> The taskID was not found </td><td>  -  </td></tr>
     </table>
   */
  public ApiResponse<Event> getTaskEventsWithHttpInfo(String taskId, String orderId) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'taskId' is set
    if (taskId == null) {
      throw new ApiException(400, "Missing the required parameter 'taskId' when calling getTaskEvents");
    }
    
    // verify the required parameter 'orderId' is set
    if (orderId == null) {
      throw new ApiException(400, "Missing the required parameter 'orderId' when calling getTaskEvents");
    }
    
    // create path and map variables
    String localVarPath = "/orders/{orderId}/tasks/{taskId}/events"
      .replaceAll("\\{" + "taskId" + "\\}", apiClient.escapeString(taskId.toString()))
      .replaceAll("\\{" + "orderId" + "\\}", apiClient.escapeString(orderId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, String> localVarCookieParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "signrestOauth2Security" };

    GenericType<Event> localVarReturnType = new GenericType<Event>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
