/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Authentication data type describes how an end user may authenticate themselves before being presented with the documents
 */
@ApiModel(description = "The Authentication data type describes how an end user may authenticate themselves before being presented with the documents")
@JsonPropertyOrder({
  Authentication.JSON_PROPERTY_METHODS,
  Authentication.JSON_PROPERTY_ARTIFACT
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class Authentication {
  public static final String JSON_PROPERTY_METHODS = "methods";
  private List<String> methods = null;

  public static final String JSON_PROPERTY_ARTIFACT = "artifact";
  private Boolean artifact;


  public Authentication methods(List<String> methods) {
    
    this.methods = methods;
    return this;
  }

  public Authentication addMethodsItem(String methodsItem) {
    if (this.methods == null) {
      this.methods = new ArrayList<>();
    }
    this.methods.add(methodsItem);
    return this;
  }

   /**
   * One or more methods. The method names should match the method definitions on the service.
   * @return methods
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "[\"nbid\",\"nbid-mobil\"]", value = "One or more methods. The method names should match the method definitions on the service.")
  @JsonProperty(JSON_PROPERTY_METHODS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getMethods() {
    return methods;
  }


  public void setMethods(List<String> methods) {
    this.methods = methods;
  }


  public Authentication artifact(Boolean artifact) {
    
    this.artifact = artifact;
    return this;
  }

   /**
   * Set to true if an authentication artifact should be generated
   * @return artifact
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "Set to true if an authentication artifact should be generated")
  @JsonProperty(JSON_PROPERTY_ARTIFACT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getArtifact() {
    return artifact;
  }


  public void setArtifact(Boolean artifact) {
    this.artifact = artifact;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Authentication authentication = (Authentication) o;
    return Objects.equals(this.methods, authentication.methods) &&
        Objects.equals(this.artifact, authentication.artifact);
  }

  @Override
  public int hashCode() {
    return Objects.hash(methods, artifact);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Authentication {\n");
    sb.append("    methods: ").append(toIndentedString(methods)).append("\n");
    sb.append("    artifact: ").append(toIndentedString(artifact)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

