/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.Form;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Document data type is used for describing a document upon which the end user should perform an action
 */
@ApiModel(description = "The Document data type is used for describing a document upon which the end user should perform an action")
@JsonPropertyOrder({
  Document.JSON_PROPERTY_ID,
  Document.JSON_PROPERTY_DESCRIPTION,
  Document.JSON_PROPERTY_ACTION,
  Document.JSON_PROPERTY_SOURCE,
  Document.JSON_PROPERTY_DOCUMENT_REF,
  Document.JSON_PROPERTY_EXTERNAL_REFERENCE,
  Document.JSON_PROPERTY_SIGN_TEXT_ENTRY,
  Document.JSON_PROPERTY_SEND_RESULT_TO_ARCHIVE,
  Document.JSON_PROPERTY_FORM
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class Document {
  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_DESCRIPTION = "description";
  private String description;

  /**
   * The action that the end user is asked to perform on this document
   */
  public enum ActionEnum {
    SIGN("SIGN"),
    
    VIEW("VIEW"),
    
    UPLOAD("UPLOAD");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String value) {
      for (ActionEnum b : ActionEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_ACTION = "action";
  private ActionEnum action;

  /**
   * The source of the document
   */
  public enum SourceEnum {
    SESSION("SESSION"),
    
    UPLOAD("UPLOAD");

    private String value;

    SourceEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SourceEnum fromValue(String value) {
      for (SourceEnum b : SourceEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_SOURCE = "source";
  private SourceEnum source;

  public static final String JSON_PROPERTY_DOCUMENT_REF = "documentRef";
  private String documentRef;

  public static final String JSON_PROPERTY_EXTERNAL_REFERENCE = "externalReference";
  private String externalReference;

  public static final String JSON_PROPERTY_SIGN_TEXT_ENTRY = "signTextEntry";
  private String signTextEntry;

  public static final String JSON_PROPERTY_SEND_RESULT_TO_ARCHIVE = "sendResultToArchive";
  private Boolean sendResultToArchive;

  public static final String JSON_PROPERTY_FORM = "form";
  private Form form;


  public Document id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * A unique identifier for this document in the signing order
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7f5be5ec-650e-4d6e-9007-e420a7dd81aa", value = "A unique identifier for this document in the signing order")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public Document description(String description) {
    
    this.description = description;
    return this;
  }

   /**
   * A human readable description of the document. This description is used in the user Interface, and also part of the Signed Data Object for some eIDs.
   * @return description
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Loan agreement", value = "A human readable description of the document. This description is used in the user Interface, and also part of the Signed Data Object for some eIDs.")
  @JsonProperty(JSON_PROPERTY_DESCRIPTION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getDescription() {
    return description;
  }


  public void setDescription(String description) {
    this.description = description;
  }


  public Document action(ActionEnum action) {
    
    this.action = action;
    return this;
  }

   /**
   * The action that the end user is asked to perform on this document
   * @return action
  **/
  @ApiModelProperty(example = "SIGN", required = true, value = "The action that the end user is asked to perform on this document")
  @JsonProperty(JSON_PROPERTY_ACTION)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public ActionEnum getAction() {
    return action;
  }


  public void setAction(ActionEnum action) {
    this.action = action;
  }


  public Document source(SourceEnum source) {
    
    this.source = source;
    return this;
  }

   /**
   * The source of the document
   * @return source
  **/
  @ApiModelProperty(example = "SESSION", required = true, value = "The source of the document")
  @JsonProperty(JSON_PROPERTY_SOURCE)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public SourceEnum getSource() {
    return source;
  }


  public void setSource(SourceEnum source) {
    this.source = source;
  }


  public Document documentRef(String documentRef) {
    
    this.documentRef = documentRef;
    return this;
  }

   /**
   * A reference to a document. If source is set to SESSION, this is the unique identifier of the document outside the signing order. If source is set to UPLOAD, then this should be omitted.
   * @return documentRef
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0807201949xfrupvbzx7o07uihsihsx3xllslasvk8qtaojow3792xjucp", value = "A reference to a document. If source is set to SESSION, this is the unique identifier of the document outside the signing order. If source is set to UPLOAD, then this should be omitted.")
  @JsonProperty(JSON_PROPERTY_DOCUMENT_REF)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getDocumentRef() {
    return documentRef;
  }


  public void setDocumentRef(String documentRef) {
    this.documentRef = documentRef;
  }


  public Document externalReference(String externalReference) {
    
    this.externalReference = externalReference;
    return this;
  }

   /**
   * Optional information about the document that will be stored in the signed data object as an external reference. Only some SDO formats supports this.
   * @return externalReference
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "427bbe68-a161-11e9-a2a3-2a2ae2dbcce4", value = "Optional information about the document that will be stored in the signed data object as an external reference. Only some SDO formats supports this.")
  @JsonProperty(JSON_PROPERTY_EXTERNAL_REFERENCE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getExternalReference() {
    return externalReference;
  }


  public void setExternalReference(String externalReference) {
    this.externalReference = externalReference;
  }


  public Document signTextEntry(String signTextEntry) {
    
    this.signTextEntry = signTextEntry;
    return this;
  }

   /**
   * Optional sign-text information that will be displayed to the end user in the final parts of the signing ceremony. May not be supported by all eID methods and document formats. Meant to be used for relatively short texts. Currently, the max length is 1024 chars.
   * @return signTextEntry
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "ID: 134256", value = "Optional sign-text information that will be displayed to the end user in the final parts of the signing ceremony. May not be supported by all eID methods and document formats. Meant to be used for relatively short texts. Currently, the max length is 1024 chars.")
  @JsonProperty(JSON_PROPERTY_SIGN_TEXT_ENTRY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSignTextEntry() {
    return signTextEntry;
  }


  public void setSignTextEntry(String signTextEntry) {
    this.signTextEntry = signTextEntry;
  }


  public Document sendResultToArchive(Boolean sendResultToArchive) {
    
    this.sendResultToArchive = sendResultToArchive;
    return this;
  }

   /**
   * If the signed or uploaded document is to be sent to the archive for permanent storage
   * @return sendResultToArchive
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "If the signed or uploaded document is to be sent to the archive for permanent storage")
  @JsonProperty(JSON_PROPERTY_SEND_RESULT_TO_ARCHIVE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getSendResultToArchive() {
    return sendResultToArchive;
  }


  public void setSendResultToArchive(Boolean sendResultToArchive) {
    this.sendResultToArchive = sendResultToArchive;
  }


  public Document form(Form form) {
    
    this.form = form;
    return this;
  }

   /**
   * Get form
   * @return form
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_FORM)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Form getForm() {
    return form;
  }


  public void setForm(Form form) {
    this.form = form;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Document document = (Document) o;
    return Objects.equals(this.id, document.id) &&
        Objects.equals(this.description, document.description) &&
        Objects.equals(this.action, document.action) &&
        Objects.equals(this.source, document.source) &&
        Objects.equals(this.documentRef, document.documentRef) &&
        Objects.equals(this.externalReference, document.externalReference) &&
        Objects.equals(this.signTextEntry, document.signTextEntry) &&
        Objects.equals(this.sendResultToArchive, document.sendResultToArchive) &&
        Objects.equals(this.form, document.form);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, description, action, source, documentRef, externalReference, signTextEntry, sendResultToArchive, form);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Document {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    source: ").append(toIndentedString(source)).append("\n");
    sb.append("    documentRef: ").append(toIndentedString(documentRef)).append("\n");
    sb.append("    externalReference: ").append(toIndentedString(externalReference)).append("\n");
    sb.append("    signTextEntry: ").append(toIndentedString(signTextEntry)).append("\n");
    sb.append("    sendResultToArchive: ").append(toIndentedString(sendResultToArchive)).append("\n");
    sb.append("    form: ").append(toIndentedString(form)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

