/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.FormParam;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The DocumentStatus data type describes a document as part of the given task
 */
@ApiModel(description = "The DocumentStatus data type describes a document as part of the given task")
@JsonPropertyOrder({
  DocumentStatus.JSON_PROPERTY_ID,
  DocumentStatus.JSON_PROPERTY_ORIGINAL_URI,
  DocumentStatus.JSON_PROPERTY_GENERATED_URI,
  DocumentStatus.JSON_PROPERTY_RESULT_URI,
  DocumentStatus.JSON_PROPERTY_FORM_OUTPUT_PARAM
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class DocumentStatus {
  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_ORIGINAL_URI = "originalUri";
  private String originalUri;

  public static final String JSON_PROPERTY_GENERATED_URI = "generatedUri";
  private String generatedUri;

  public static final String JSON_PROPERTY_RESULT_URI = "resultUri";
  private String resultUri;

  public static final String JSON_PROPERTY_FORM_OUTPUT_PARAM = "formOutputParam";
  private List<FormParam> formOutputParam = null;


  public DocumentStatus id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * The unique identifier of the original document in the signing order
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "fbcf52a7-a952-41fc-82d9-beefbe094f6f", value = "The unique identifier of the original document in the signing order")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public DocumentStatus originalUri(String originalUri) {
    
    this.originalUri = originalUri;
    return this;
  }

   /**
   * URI for the original document
   * @return originalUri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://id.signicat.com/sign/orders/<SIGNINGORDER_ID/tasks/<TASK_ID>/documents/<DOCUMENT-ID>/original", value = "URI for the original document")
  @JsonProperty(JSON_PROPERTY_ORIGINAL_URI)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOriginalUri() {
    return originalUri;
  }


  public void setOriginalUri(String originalUri) {
    this.originalUri = originalUri;
  }


  public DocumentStatus generatedUri(String generatedUri) {
    
    this.generatedUri = generatedUri;
    return this;
  }

   /**
   * URI for the generated document
   * @return generatedUri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://id.signicat.com/sign/orders/<SIGNINGORDER-ID>/tasks/<TASK-ID>/documents/<DOCUMENT-ID>/generated", value = "URI for the generated document")
  @JsonProperty(JSON_PROPERTY_GENERATED_URI)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getGeneratedUri() {
    return generatedUri;
  }


  public void setGeneratedUri(String generatedUri) {
    this.generatedUri = generatedUri;
  }


  public DocumentStatus resultUri(String resultUri) {
    
    this.resultUri = resultUri;
    return this;
  }

   /**
   * URI for the result document
   * @return resultUri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://id.signicat.com/sign/orders/<SIGNINGORDER-ID>/tasks/<TASK-ID>/documents/<DOCUMENT-ID>/result", value = "URI for the result document")
  @JsonProperty(JSON_PROPERTY_RESULT_URI)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getResultUri() {
    return resultUri;
  }


  public void setResultUri(String resultUri) {
    this.resultUri = resultUri;
  }


  public DocumentStatus formOutputParam(List<FormParam> formOutputParam) {
    
    this.formOutputParam = formOutputParam;
    return this;
  }

  public DocumentStatus addFormOutputParamItem(FormParam formOutputParamItem) {
    if (this.formOutputParam == null) {
      this.formOutputParam = new ArrayList<>();
    }
    this.formOutputParam.add(formOutputParamItem);
    return this;
  }

   /**
   * Form parameters that were either prefilled and/or filled in by the end user
   * @return formOutputParam
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Form parameters that were either prefilled and/or filled in by the end user")
  @JsonProperty(JSON_PROPERTY_FORM_OUTPUT_PARAM)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<FormParam> getFormOutputParam() {
    return formOutputParam;
  }


  public void setFormOutputParam(List<FormParam> formOutputParam) {
    this.formOutputParam = formOutputParam;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DocumentStatus documentStatus = (DocumentStatus) o;
    return Objects.equals(this.id, documentStatus.id) &&
        Objects.equals(this.originalUri, documentStatus.originalUri) &&
        Objects.equals(this.generatedUri, documentStatus.generatedUri) &&
        Objects.equals(this.resultUri, documentStatus.resultUri) &&
        Objects.equals(this.formOutputParam, documentStatus.formOutputParam);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, originalUri, generatedUri, resultUri, formOutputParam);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DocumentStatus {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    originalUri: ").append(toIndentedString(originalUri)).append("\n");
    sb.append("    generatedUri: ").append(toIndentedString(generatedUri)).append("\n");
    sb.append("    resultUri: ").append(toIndentedString(resultUri)).append("\n");
    sb.append("    formOutputParam: ").append(toIndentedString(formOutputParam)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

