/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.OffsetDateTime;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Event data type describes an event that has occurred in the signing order
 */
@ApiModel(description = "The Event data type describes an event that has occurred in the signing order")
@JsonPropertyOrder({
  Event.JSON_PROPERTY_EVENT_TYPE,
  Event.JSON_PROPERTY_EVENT_TIME,
  Event.JSON_PROPERTY_DATA
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class Event {
  /**
   * The type of the event that has occured
   */
  public enum EventTypeEnum {
    TASK_CREATED("TASK_CREATED"),
    
    NOTIFICATION_SENT("NOTIFICATION_SENT"),
    
    TASK_STARTED("TASK_STARTED"),
    
    TASK_REJECTED("TASK_REJECTED"),
    
    TASK_POSTPONED("TASK_POSTPONED"),
    
    TASK_COMPLETED("TASK_COMPLETED"),
    
    ERROR("ERROR"),
    
    DOCUMENT_UPLOADED("DOCUMENT_UPLOADED"),
    
    DOCUMENT_SIGNED("DOCUMENT_SIGNED"),
    
    DOCUMENT_VIEWED("DOCUMENT_VIEWED"),
    
    DOCUMENT_SIGN_CANCELLED("DOCUMENT_SIGN_CANCELLED"),
    
    DOCUMENT_DELETED("DOCUMENT_DELETED"),
    
    USER_AUTHENTICATED("USER_AUTHENTICATED"),
    
    USER_AUTHENTICATION_CANCELLED("USER_AUTHENTICATION_CANCELLED"),
    
    PACKAGING_TASK_CREATED("PACKAGING_TASK_CREATED"),
    
    PACKAGING_TASK_COMPLETED("PACKAGING_TASK_COMPLETED"),
    
    PACKAGING_TASK_FAILED("PACKAGING_TASK_FAILED"),
    
    INTERNAL("INTERNAL");

    private String value;

    EventTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static EventTypeEnum fromValue(String value) {
      for (EventTypeEnum b : EventTypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_EVENT_TYPE = "eventType";
  private EventTypeEnum eventType;

  public static final String JSON_PROPERTY_EVENT_TIME = "eventTime";
  private OffsetDateTime eventTime;

  public static final String JSON_PROPERTY_DATA = "data";
  private String data;


  public Event eventType(EventTypeEnum eventType) {
    
    this.eventType = eventType;
    return this;
  }

   /**
   * The type of the event that has occured
   * @return eventType
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "notification-sent", value = "The type of the event that has occured")
  @JsonProperty(JSON_PROPERTY_EVENT_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public EventTypeEnum getEventType() {
    return eventType;
  }


  public void setEventType(EventTypeEnum eventType) {
    this.eventType = eventType;
  }


  public Event eventTime(OffsetDateTime eventTime) {
    
    this.eventTime = eventTime;
    return this;
  }

   /**
   * The time of the event. The pattern will be \&quot;yyyy-MM-dd&#39;T&#39;HH:mm:ssZ\&quot;.
   * @return eventTime
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "The time of the event. The pattern will be \"yyyy-MM-dd'T'HH:mm:ssZ\".")
  @JsonProperty(JSON_PROPERTY_EVENT_TIME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public OffsetDateTime getEventTime() {
    return eventTime;
  }


  public void setEventTime(OffsetDateTime eventTime) {
    this.eventTime = eventTime;
  }


  public Event data(String data) {
    
    this.data = data;
    return this;
  }

   /**
   * Some event types define additional data to give more detail about the event that occurred
   * @return data
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Notification by EMAIL was sent to noreply@signicat.com", value = "Some event types define additional data to give more detail about the event that occurred")
  @JsonProperty(JSON_PROPERTY_DATA)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getData() {
    return data;
  }


  public void setData(String data) {
    this.data = data;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Event event = (Event) o;
    return Objects.equals(this.eventType, event.eventType) &&
        Objects.equals(this.eventTime, event.eventTime) &&
        Objects.equals(this.data, event.data);
  }

  @Override
  public int hashCode() {
    return Objects.hash(eventType, eventTime, data);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Event {\n");
    sb.append("    eventType: ").append(toIndentedString(eventType)).append("\n");
    sb.append("    eventTime: ").append(toIndentedString(eventTime)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

