/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.FormParam;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Form data type is used when requesting an input form. This is only relevant if you are using Signicat Forms.
 */
@ApiModel(description = "The Form data type is used when requesting an input form. This is only relevant if you are using Signicat Forms.")
@JsonPropertyOrder({
  Form.JSON_PROPERTY_INTERACTIVE,
  Form.JSON_PROPERTY_INPUT_PARAMS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class Form {
  public static final String JSON_PROPERTY_INTERACTIVE = "interactive";
  private Boolean interactive;

  public static final String JSON_PROPERTY_INPUT_PARAMS = "inputParams";
  private List<FormParam> inputParams = null;


  public Form interactive(Boolean interactive) {
    
    this.interactive = interactive;
    return this;
  }

   /**
   * Set to true if the form should be interactive
   * @return interactive
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Set to true if the form should be interactive")
  @JsonProperty(JSON_PROPERTY_INTERACTIVE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getInteractive() {
    return interactive;
  }


  public void setInteractive(Boolean interactive) {
    this.interactive = interactive;
  }


  public Form inputParams(List<FormParam> inputParams) {
    
    this.inputParams = inputParams;
    return this;
  }

  public Form addInputParamsItem(FormParam inputParamsItem) {
    if (this.inputParams == null) {
      this.inputParams = new ArrayList<>();
    }
    this.inputParams.add(inputParamsItem);
    return this;
  }

   /**
   * A list of parameters to be prefilled in the form
   * @return inputParams
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "A list of parameters to be prefilled in the form")
  @JsonProperty(JSON_PROPERTY_INPUT_PARAMS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<FormParam> getInputParams() {
    return inputParams;
  }


  public void setInputParams(List<FormParam> inputParams) {
    this.inputParams = inputParams;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Form form = (Form) o;
    return Objects.equals(this.interactive, form.interactive) &&
        Objects.equals(this.inputParams, form.inputParams);
  }

  @Override
  public int hashCode() {
    return Objects.hash(interactive, inputParams);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Form {\n");
    sb.append("    interactive: ").append(toIndentedString(interactive)).append("\n");
    sb.append("    inputParams: ").append(toIndentedString(inputParams)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

