/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Method data type specifies the name of an eID method to use for signing, the type of the method and if a handwritten signature should be applied or not
 */
@ApiModel(description = "The Method data type specifies the name of an eID method to use for signing, the type of the method and if a handwritten signature should be applied or not")
@JsonPropertyOrder({
  Method.JSON_PROPERTY_NAME,
  Method.JSON_PROPERTY_TYPE,
  Method.JSON_PROPERTY_HANDWRITTEN
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class Method {
  public static final String JSON_PROPERTY_NAME = "name";
  private String name;

  /**
   * The type of signature to create using the given method
   */
  public enum TypeEnum {
    AUTHENTICATION_BASED("AUTHENTICATION_BASED"),
    
    SIGNED_STATEMENT("SIGNED_STATEMENT"),
    
    THIRD_PARTY("THIRD_PARTY");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String value) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_TYPE = "type";
  private TypeEnum type;

  public static final String JSON_PROPERTY_HANDWRITTEN = "handwritten";
  private Boolean handwritten;


  public Method name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * The name of the eID method. If the name is specified, the type must also be specified.
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "nbid-sign", value = "The name of the eID method. If the name is specified, the type must also be specified.")
  @JsonProperty(JSON_PROPERTY_NAME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public Method type(TypeEnum type) {
    
    this.type = type;
    return this;
  }

   /**
   * The type of signature to create using the given method
   * @return type
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "SIGNED_STATEMENT", value = "The type of signature to create using the given method")
  @JsonProperty(JSON_PROPERTY_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public TypeEnum getType() {
    return type;
  }


  public void setType(TypeEnum type) {
    this.type = type;
  }


  public Method handwritten(Boolean handwritten) {
    
    this.handwritten = handwritten;
    return this;
  }

   /**
   * Set to true if a handwritten signature should be applied after signing. If set to true with no method name given, only a handwritten signature will be requested.
   * @return handwritten
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "Set to true if a handwritten signature should be applied after signing. If set to true with no method name given, only a handwritten signature will be requested.")
  @JsonProperty(JSON_PROPERTY_HANDWRITTEN)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getHandwritten() {
    return handwritten;
  }


  public void setHandwritten(Boolean handwritten) {
    this.handwritten = handwritten;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Method method = (Method) o;
    return Objects.equals(this.name, method.name) &&
        Objects.equals(this.type, method.type) &&
        Objects.equals(this.handwritten, method.handwritten);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, handwritten);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Method {\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    handwritten: ").append(toIndentedString(handwritten)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

