/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.PackagingTaskDocument;
import com.example.demo.signapi.client.model.PackagingTaskNotification;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The PackagingTask data type describes a packaging operation to be performed on one or more signed documents, e.g. packaging one or more XAdES documents into a single PAdES document. The input to the operation is a set of signed documents resulting from the regular tasks in the current request. For packaging across document action requests, the PackagingService must be used.
 */
@ApiModel(description = "The PackagingTask data type describes a packaging operation to be performed on one or more signed documents, e.g. packaging one or more XAdES documents into a single PAdES document. The input to the operation is a set of signed documents resulting from the regular tasks in the current request. For packaging across document action requests, the PackagingService must be used.")
@JsonPropertyOrder({
  PackagingTask.JSON_PROPERTY_ID,
  PackagingTask.JSON_PROPERTY_SEND_TO_ARCHIVE,
  PackagingTask.JSON_PROPERTY_METHOD,
  PackagingTask.JSON_PROPERTY_NOTIFICATIONS,
  PackagingTask.JSON_PROPERTY_DOCUMENTS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class PackagingTask {
  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_SEND_TO_ARCHIVE = "sendToArchive";
  private Boolean sendToArchive;

  public static final String JSON_PROPERTY_METHOD = "method";
  private String method;

  public static final String JSON_PROPERTY_NOTIFICATIONS = "notifications";
  private List<PackagingTaskNotification> notifications = null;

  public static final String JSON_PROPERTY_DOCUMENTS = "documents";
  private List<PackagingTaskDocument> documents = null;


  public PackagingTask id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * A unique identifier for this packaging task. The id must be specified by the client that creates the packaging task. The id must be unique among all ids in the Packaging Task list.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "83241c55-8813-495c-9d2f-390b6a39ea29", value = "A unique identifier for this packaging task. The id must be specified by the client that creates the packaging task. The id must be unique among all ids in the Packaging Task list.")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public PackagingTask sendToArchive(Boolean sendToArchive) {
    
    this.sendToArchive = sendToArchive;
    return this;
  }

   /**
   * Set to true if the result of the packaging task is to be sent to the archive for permanent storage after it is packaged. Default value: false.
   * @return sendToArchive
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "Set to true if the result of the packaging task is to be sent to the archive for permanent storage after it is packaged. Default value: false.")
  @JsonProperty(JSON_PROPERTY_SEND_TO_ARCHIVE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getSendToArchive() {
    return sendToArchive;
  }


  public void setSendToArchive(Boolean sendToArchive) {
    this.sendToArchive = sendToArchive;
  }


  public PackagingTask method(String method) {
    
    this.method = method;
    return this;
  }

   /**
   * The name of the packaging method to be used in the packaging task. The method name should match the method definition on the service.
   * @return method
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "pades", value = "The name of the packaging method to be used in the packaging task. The method name should match the method definition on the service.")
  @JsonProperty(JSON_PROPERTY_METHOD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getMethod() {
    return method;
  }


  public void setMethod(String method) {
    this.method = method;
  }


  public PackagingTask notifications(List<PackagingTaskNotification> notifications) {
    
    this.notifications = notifications;
    return this;
  }

  public PackagingTask addNotificationsItem(PackagingTaskNotification notificationsItem) {
    if (this.notifications == null) {
      this.notifications = new ArrayList<>();
    }
    this.notifications.add(notificationsItem);
    return this;
  }

   /**
   * Notifications that should be sent out either when this packaging task is created or later (as specified in the notification).
   * @return notifications
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Notifications that should be sent out either when this packaging task is created or later (as specified in the notification).")
  @JsonProperty(JSON_PROPERTY_NOTIFICATIONS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<PackagingTaskNotification> getNotifications() {
    return notifications;
  }


  public void setNotifications(List<PackagingTaskNotification> notifications) {
    this.notifications = notifications;
  }


  public PackagingTask documents(List<PackagingTaskDocument> documents) {
    
    this.documents = documents;
    return this;
  }

  public PackagingTask addDocumentsItem(PackagingTaskDocument documentsItem) {
    if (this.documents == null) {
      this.documents = new ArrayList<>();
    }
    this.documents.add(documentsItem);
    return this;
  }

   /**
   * Documents to be used as input to this packaging task. See the documentation of the PackagingTaskDocument data type.
   * @return documents
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Documents to be used as input to this packaging task. See the documentation of the PackagingTaskDocument data type.")
  @JsonProperty(JSON_PROPERTY_DOCUMENTS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<PackagingTaskDocument> getDocuments() {
    return documents;
  }


  public void setDocuments(List<PackagingTaskDocument> documents) {
    this.documents = documents;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PackagingTask packagingTask = (PackagingTask) o;
    return Objects.equals(this.id, packagingTask.id) &&
        Objects.equals(this.sendToArchive, packagingTask.sendToArchive) &&
        Objects.equals(this.method, packagingTask.method) &&
        Objects.equals(this.notifications, packagingTask.notifications) &&
        Objects.equals(this.documents, packagingTask.documents);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, sendToArchive, method, notifications, documents);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PackagingTask {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    sendToArchive: ").append(toIndentedString(sendToArchive)).append("\n");
    sb.append("    method: ").append(toIndentedString(method)).append("\n");
    sb.append("    notifications: ").append(toIndentedString(notifications)).append("\n");
    sb.append("    documents: ").append(toIndentedString(documents)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

