/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The PackagingTask data type groups together signed documents that belong to the same task in order to be packed into a single PAdES document.
 */
@ApiModel(description = "The PackagingTask data type groups together signed documents that belong to the same task in order to be packed into a single PAdES document.")
@JsonPropertyOrder({
  PackagingTaskDocument.JSON_PROPERTY_TASK_ID,
  PackagingTaskDocument.JSON_PROPERTY_DOCUMENT_IDS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class PackagingTaskDocument {
  public static final String JSON_PROPERTY_TASK_ID = "taskId";
  private String taskId;

  public static final String JSON_PROPERTY_DOCUMENT_IDS = "documentIds";
  private List<String> documentIds = null;


  public PackagingTaskDocument taskId(String taskId) {
    
    this.taskId = taskId;
    return this;
  }

   /**
   * The unique identifier of the task
   * @return taskId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "b8a5ccdc-d79b-412e-a20e-03c2a8c8cdd2", value = "The unique identifier of the task")
  @JsonProperty(JSON_PROPERTY_TASK_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getTaskId() {
    return taskId;
  }


  public void setTaskId(String taskId) {
    this.taskId = taskId;
  }


  public PackagingTaskDocument documentIds(List<String> documentIds) {
    
    this.documentIds = documentIds;
    return this;
  }

  public PackagingTaskDocument addDocumentIdsItem(String documentIdsItem) {
    if (this.documentIds == null) {
      this.documentIds = new ArrayList<>();
    }
    this.documentIds.add(documentIdsItem);
    return this;
  }

   /**
   * List of document IDs to include from the task with the given taskId.
   * @return documentIds
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "[\"7f5be5ec-650e-4d6e-9007-e420a7dd81aa\"]", value = "List of document IDs to include from the task with the given taskId.")
  @JsonProperty(JSON_PROPERTY_DOCUMENT_IDS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getDocumentIds() {
    return documentIds;
  }


  public void setDocumentIds(List<String> documentIds) {
    this.documentIds = documentIds;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PackagingTaskDocument packagingTaskDocument = (PackagingTaskDocument) o;
    return Objects.equals(this.taskId, packagingTaskDocument.taskId) &&
        Objects.equals(this.documentIds, packagingTaskDocument.documentIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(taskId, documentIds);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PackagingTaskDocument {\n");
    sb.append("    taskId: ").append(toIndentedString(taskId)).append("\n");
    sb.append("    documentIds: ").append(toIndentedString(documentIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

