/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The PackagingTaskSchedule data type specifies when a packaging task notification should be sent.
 */
@ApiModel(description = "The PackagingTaskSchedule data type specifies when a packaging task notification should be sent.")
@JsonPropertyOrder({
  PackagingTaskSchedule.JSON_PROPERTY_TRIGGER_STATUS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class PackagingTaskSchedule {
  /**
   * The status a packaging task needs to have in order to trigger a notification
   */
  public enum TriggerStatusEnum {
    CREATED("CREATED"),
    
    COMPLETED("COMPLETED"),
    
    FAILED("FAILED");

    private String value;

    TriggerStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TriggerStatusEnum fromValue(String value) {
      for (TriggerStatusEnum b : TriggerStatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_TRIGGER_STATUS = "triggerStatus";
  private TriggerStatusEnum triggerStatus;


  public PackagingTaskSchedule triggerStatus(TriggerStatusEnum triggerStatus) {
    
    this.triggerStatus = triggerStatus;
    return this;
  }

   /**
   * The status a packaging task needs to have in order to trigger a notification
   * @return triggerStatus
  **/
  @ApiModelProperty(example = "COMPLETED", required = true, value = "The status a packaging task needs to have in order to trigger a notification")
  @JsonProperty(JSON_PROPERTY_TRIGGER_STATUS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public TriggerStatusEnum getTriggerStatus() {
    return triggerStatus;
  }


  public void setTriggerStatus(TriggerStatusEnum triggerStatus) {
    this.triggerStatus = triggerStatus;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PackagingTaskSchedule packagingTaskSchedule = (PackagingTaskSchedule) o;
    return Objects.equals(this.triggerStatus, packagingTaskSchedule.triggerStatus);
  }

  @Override
  public int hashCode() {
    return Objects.hash(triggerStatus);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PackagingTaskSchedule {\n");
    sb.append("    triggerStatus: ").append(toIndentedString(triggerStatus)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

