/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The PackagingTaskStatusInfo data type describes the status of a specific packaging task
 */
@ApiModel(description = "The PackagingTaskStatusInfo data type describes the status of a specific packaging task")
@JsonPropertyOrder({
  PackagingTaskStatusInfo.JSON_PROPERTY_ORDER_ID,
  PackagingTaskStatusInfo.JSON_PROPERTY_PACKAGING_TASK_ID,
  PackagingTaskStatusInfo.JSON_PROPERTY_PACKAGING_TASK_STATUS,
  PackagingTaskStatusInfo.JSON_PROPERTY_PACKAGING_TASK_RESULT_URI
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class PackagingTaskStatusInfo {
  public static final String JSON_PROPERTY_ORDER_ID = "orderId";
  private String orderId;

  public static final String JSON_PROPERTY_PACKAGING_TASK_ID = "packagingTaskId";
  private String packagingTaskId;

  /**
   * The status of the packaging task
   */
  public enum PackagingTaskStatusEnum {
    CREATED("CREATED"),
    
    COMPLETED("COMPLETED"),
    
    FAILED("FAILED");

    private String value;

    PackagingTaskStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PackagingTaskStatusEnum fromValue(String value) {
      for (PackagingTaskStatusEnum b : PackagingTaskStatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_PACKAGING_TASK_STATUS = "packagingTaskStatus";
  private PackagingTaskStatusEnum packagingTaskStatus;

  public static final String JSON_PROPERTY_PACKAGING_TASK_RESULT_URI = "packagingTaskResultUri";
  private String packagingTaskResultUri;


  public PackagingTaskStatusInfo orderId(String orderId) {
    
    this.orderId = orderId;
    return this;
  }

   /**
   * The unique identifier of the signing order
   * @return orderId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "05022019298twl5n4wo4soavolfwnxev9rxfghqapyk8junju1wxqamkeq", value = "The unique identifier of the signing order")
  @JsonProperty(JSON_PROPERTY_ORDER_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOrderId() {
    return orderId;
  }


  public void setOrderId(String orderId) {
    this.orderId = orderId;
  }


  public PackagingTaskStatusInfo packagingTaskId(String packagingTaskId) {
    
    this.packagingTaskId = packagingTaskId;
    return this;
  }

   /**
   * The unique identifier of the packaging task
   * @return packagingTaskId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "f727d294-a3b9-49c7-af99-4a217fc1d8fd", value = "The unique identifier of the packaging task")
  @JsonProperty(JSON_PROPERTY_PACKAGING_TASK_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getPackagingTaskId() {
    return packagingTaskId;
  }


  public void setPackagingTaskId(String packagingTaskId) {
    this.packagingTaskId = packagingTaskId;
  }


  public PackagingTaskStatusInfo packagingTaskStatus(PackagingTaskStatusEnum packagingTaskStatus) {
    
    this.packagingTaskStatus = packagingTaskStatus;
    return this;
  }

   /**
   * The status of the packaging task
   * @return packagingTaskStatus
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "COMPLETED", value = "The status of the packaging task")
  @JsonProperty(JSON_PROPERTY_PACKAGING_TASK_STATUS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public PackagingTaskStatusEnum getPackagingTaskStatus() {
    return packagingTaskStatus;
  }


  public void setPackagingTaskStatus(PackagingTaskStatusEnum packagingTaskStatus) {
    this.packagingTaskStatus = packagingTaskStatus;
  }


  public PackagingTaskStatusInfo packagingTaskResultUri(String packagingTaskResultUri) {
    
    this.packagingTaskResultUri = packagingTaskResultUri;
    return this;
  }

   /**
   * URI to the result of the packaging operation
   * @return packagingTaskResultUri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://id.signicat.com/sign/orders/<SIGNINGORDER-ID>/packaging-tasks/<PACKAGING-TASK-ID>/result", value = "URI to the result of the packaging operation")
  @JsonProperty(JSON_PROPERTY_PACKAGING_TASK_RESULT_URI)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getPackagingTaskResultUri() {
    return packagingTaskResultUri;
  }


  public void setPackagingTaskResultUri(String packagingTaskResultUri) {
    this.packagingTaskResultUri = packagingTaskResultUri;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PackagingTaskStatusInfo packagingTaskStatusInfo = (PackagingTaskStatusInfo) o;
    return Objects.equals(this.orderId, packagingTaskStatusInfo.orderId) &&
        Objects.equals(this.packagingTaskId, packagingTaskStatusInfo.packagingTaskId) &&
        Objects.equals(this.packagingTaskStatus, packagingTaskStatusInfo.packagingTaskStatus) &&
        Objects.equals(this.packagingTaskResultUri, packagingTaskStatusInfo.packagingTaskResultUri);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orderId, packagingTaskId, packagingTaskStatus, packagingTaskResultUri);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PackagingTaskStatusInfo {\n");
    sb.append("    orderId: ").append(toIndentedString(orderId)).append("\n");
    sb.append("    packagingTaskId: ").append(toIndentedString(packagingTaskId)).append("\n");
    sb.append("    packagingTaskStatus: ").append(toIndentedString(packagingTaskStatus)).append("\n");
    sb.append("    packagingTaskResultUri: ").append(toIndentedString(packagingTaskResultUri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

