/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.PackagingTask;
import com.example.demo.signapi.client.model.SigningOrderNotification;
import com.example.demo.signapi.client.model.Task;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The SigingOrder data type describes a signing order for an action on one or more documents by one or more subjects.
 */
@ApiModel(description = "The SigingOrder data type describes a signing order for an action on one or more documents by one or more subjects.")
@JsonPropertyOrder({
  SigningOrder.JSON_PROPERTY_CLIENT_REFERENCE,
  SigningOrder.JSON_PROPERTY_TASKS,
  SigningOrder.JSON_PROPERTY_NOTIFICATIONS,
  SigningOrder.JSON_PROPERTY_DAYS_UNTIL_DELETION,
  SigningOrder.JSON_PROPERTY_PACKAGING_TASKS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class SigningOrder {
  public static final String JSON_PROPERTY_CLIENT_REFERENCE = "clientReference";
  private String clientReference;

  public static final String JSON_PROPERTY_TASKS = "tasks";
  private List<Task> tasks = new ArrayList<>();

  public static final String JSON_PROPERTY_NOTIFICATIONS = "notifications";
  private List<SigningOrderNotification> notifications = null;

  public static final String JSON_PROPERTY_DAYS_UNTIL_DELETION = "daysUntilDeletion";
  private Integer daysUntilDeletion;

  public static final String JSON_PROPERTY_PACKAGING_TASKS = "packagingTasks";
  private List<PackagingTask> packagingTasks = null;


  public SigningOrder clientReference(String clientReference) {
    
    this.clientReference = clientReference;
    return this;
  }

   /**
   * A client specific reference. This value will not be used by the service, but will be returned to the client.
   * @return clientReference
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "b8a5ccdc-d79b-412e-a20e-03c2a8c8cdd2", value = "A client specific reference. This value will not be used by the service, but will be returned to the client.")
  @JsonProperty(JSON_PROPERTY_CLIENT_REFERENCE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getClientReference() {
    return clientReference;
  }


  public void setClientReference(String clientReference) {
    this.clientReference = clientReference;
  }


  public SigningOrder tasks(List<Task> tasks) {
    
    this.tasks = tasks;
    return this;
  }

  public SigningOrder addTasksItem(Task tasksItem) {
    this.tasks.add(tasksItem);
    return this;
  }

   /**
   * One or more tasks. See the documentation of the Task data type.
   * @return tasks
  **/
  @ApiModelProperty(required = true, value = "One or more tasks. See the documentation of the Task data type.")
  @JsonProperty(JSON_PROPERTY_TASKS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public List<Task> getTasks() {
    return tasks;
  }


  public void setTasks(List<Task> tasks) {
    this.tasks = tasks;
  }


  public SigningOrder notifications(List<SigningOrderNotification> notifications) {
    
    this.notifications = notifications;
    return this;
  }

  public SigningOrder addNotificationsItem(SigningOrderNotification notificationsItem) {
    if (this.notifications == null) {
      this.notifications = new ArrayList<>();
    }
    this.notifications.add(notificationsItem);
    return this;
  }

   /**
   * One or more notifications that will be sent when the signing order has been completed
   * @return notifications
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "One or more notifications that will be sent when the signing order has been completed")
  @JsonProperty(JSON_PROPERTY_NOTIFICATIONS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<SigningOrderNotification> getNotifications() {
    return notifications;
  }


  public void setNotifications(List<SigningOrderNotification> notifications) {
    this.notifications = notifications;
  }


  public SigningOrder daysUntilDeletion(Integer daysUntilDeletion) {
    
    this.daysUntilDeletion = daysUntilDeletion;
    return this;
  }

   /**
   * The number of days before the signing order is automatically deleted from Signicat’s storage, after every task&#39;s days-to-live have passed. (see daysToLive on the Task element). Documents in the archive will not be deleted even if the signing order that created the documents is deleted. All documents that are not in the archive will be deleted.
   * minimum: 1
   * maximum: 30
   * @return daysUntilDeletion
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7", value = "The number of days before the signing order is automatically deleted from Signicat’s storage, after every task's days-to-live have passed. (see daysToLive on the Task element). Documents in the archive will not be deleted even if the signing order that created the documents is deleted. All documents that are not in the archive will be deleted.")
  @JsonProperty(JSON_PROPERTY_DAYS_UNTIL_DELETION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getDaysUntilDeletion() {
    return daysUntilDeletion;
  }


  public void setDaysUntilDeletion(Integer daysUntilDeletion) {
    this.daysUntilDeletion = daysUntilDeletion;
  }


  public SigningOrder packagingTasks(List<PackagingTask> packagingTasks) {
    
    this.packagingTasks = packagingTasks;
    return this;
  }

  public SigningOrder addPackagingTasksItem(PackagingTask packagingTasksItem) {
    if (this.packagingTasks == null) {
      this.packagingTasks = new ArrayList<>();
    }
    this.packagingTasks.add(packagingTasksItem);
    return this;
  }

   /**
   * Get packagingTasks
   * @return packagingTasks
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_PACKAGING_TASKS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<PackagingTask> getPackagingTasks() {
    return packagingTasks;
  }


  public void setPackagingTasks(List<PackagingTask> packagingTasks) {
    this.packagingTasks = packagingTasks;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SigningOrder signingOrder = (SigningOrder) o;
    return Objects.equals(this.clientReference, signingOrder.clientReference) &&
        Objects.equals(this.tasks, signingOrder.tasks) &&
        Objects.equals(this.notifications, signingOrder.notifications) &&
        Objects.equals(this.daysUntilDeletion, signingOrder.daysUntilDeletion) &&
        Objects.equals(this.packagingTasks, signingOrder.packagingTasks);
  }

  @Override
  public int hashCode() {
    return Objects.hash(clientReference, tasks, notifications, daysUntilDeletion, packagingTasks);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SigningOrder {\n");
    sb.append("    clientReference: ").append(toIndentedString(clientReference)).append("\n");
    sb.append("    tasks: ").append(toIndentedString(tasks)).append("\n");
    sb.append("    notifications: ").append(toIndentedString(notifications)).append("\n");
    sb.append("    daysUntilDeletion: ").append(toIndentedString(daysUntilDeletion)).append("\n");
    sb.append("    packagingTasks: ").append(toIndentedString(packagingTasks)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

