/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The subject attribute data type specifies the attributes that will be used to validate the signer after the signer has either signed the document(s) or authenticated himself or herself
 */
@ApiModel(description = "The subject attribute data type specifies the attributes that will be used to validate the signer after the signer has either signed the document(s) or authenticated himself or herself")
@JsonPropertyOrder({
  SubjectAttribute.JSON_PROPERTY_NAME,
  SubjectAttribute.JSON_PROPERTY_VALUE,
  SubjectAttribute.JSON_PROPERTY_METHODS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class SubjectAttribute {
  public static final String JSON_PROPERTY_NAME = "name";
  private String name;

  public static final String JSON_PROPERTY_VALUE = "value";
  private String value;

  public static final String JSON_PROPERTY_METHODS = "methods";
  private List<String> methods = null;


  public SubjectAttribute name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * The name of the attribute to validate against
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "national-id", value = "The name of the attribute to validate against")
  @JsonProperty(JSON_PROPERTY_NAME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public SubjectAttribute value(String value) {
    
    this.value = value;
    return this;
  }

   /**
   * The value of the attribute to validate against
   * @return value
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "10109001290", value = "The value of the attribute to validate against")
  @JsonProperty(JSON_PROPERTY_VALUE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getValue() {
    return value;
  }


  public void setValue(String value) {
    this.value = value;
  }


  public SubjectAttribute methods(List<String> methods) {
    
    this.methods = methods;
    return this;
  }

  public SubjectAttribute addMethodsItem(String methodsItem) {
    if (this.methods == null) {
      this.methods = new ArrayList<>();
    }
    this.methods.add(methodsItem);
    return this;
  }

   /**
   * If configured this attribute will supersede the general subject attribute with the same name
   * @return methods
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "[\"nbid-sign\"]", value = "If configured this attribute will supersede the general subject attribute with the same name")
  @JsonProperty(JSON_PROPERTY_METHODS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getMethods() {
    return methods;
  }


  public void setMethods(List<String> methods) {
    this.methods = methods;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SubjectAttribute subjectAttribute = (SubjectAttribute) o;
    return Objects.equals(this.name, subjectAttribute.name) &&
        Objects.equals(this.value, subjectAttribute.value) &&
        Objects.equals(this.methods, subjectAttribute.methods);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, value, methods);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SubjectAttribute {\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("    methods: ").append(toIndentedString(methods)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

