/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.Authentication;
import com.example.demo.signapi.client.model.Dialog;
import com.example.demo.signapi.client.model.Document;
import com.example.demo.signapi.client.model.Method;
import com.example.demo.signapi.client.model.Subject;
import com.example.demo.signapi.client.model.TaskNotification;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Task data type describes a specific task for an end user. A task could be to sign one or more documents or to open and view a document. A task can require the end user to log in. A task will always have one and only one end user (subject).
 */
@ApiModel(description = "The Task data type describes a specific task for an end user. A task could be to sign one or more documents or to open and view a document. A task can require the end user to log in. A task will always have one and only one end user (subject).")
@JsonPropertyOrder({
  Task.JSON_PROPERTY_ID,
  Task.JSON_PROPERTY_PROFILE,
  Task.JSON_PROPERTY_LANGUAGE,
  Task.JSON_PROPERTY_DAYS_TO_LIVE,
  Task.JSON_PROPERTY_CONFIGURATION,
  Task.JSON_PROPERTY_DOCUMENTS,
  Task.JSON_PROPERTY_SIGNATURE_METHODS,
  Task.JSON_PROPERTY_AUTHENTICATION,
  Task.JSON_PROPERTY_ON_TASK_POSTPONE,
  Task.JSON_PROPERTY_ON_TASK_COMPLETE,
  Task.JSON_PROPERTY_ON_TASK_REJECT,
  Task.JSON_PROPERTY_DIALOG,
  Task.JSON_PROPERTY_NOTIFICATIONS,
  Task.JSON_PROPERTY_SIGN_TEXT,
  Task.JSON_PROPERTY_SUBJECT,
  Task.JSON_PROPERTY_DEPENDS_ON_TASKS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class Task {
  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_PROFILE = "profile";
  private String profile;

  public static final String JSON_PROPERTY_LANGUAGE = "language";
  private String language;

  public static final String JSON_PROPERTY_DAYS_TO_LIVE = "daysToLive";
  private Integer daysToLive;

  public static final String JSON_PROPERTY_CONFIGURATION = "configuration";
  private String _configuration;

  public static final String JSON_PROPERTY_DOCUMENTS = "documents";
  private List<Document> documents = new ArrayList<>();

  public static final String JSON_PROPERTY_SIGNATURE_METHODS = "signatureMethods";
  private List<Method> signatureMethods = new ArrayList<>();

  public static final String JSON_PROPERTY_AUTHENTICATION = "authentication";
  private Authentication authentication;

  public static final String JSON_PROPERTY_ON_TASK_POSTPONE = "onTaskPostpone";
  private String onTaskPostpone;

  public static final String JSON_PROPERTY_ON_TASK_COMPLETE = "onTaskComplete";
  private String onTaskComplete;

  public static final String JSON_PROPERTY_ON_TASK_REJECT = "onTaskReject";
  private String onTaskReject;

  public static final String JSON_PROPERTY_DIALOG = "dialog";
  private Dialog dialog;

  public static final String JSON_PROPERTY_NOTIFICATIONS = "notifications";
  private List<TaskNotification> notifications = null;

  public static final String JSON_PROPERTY_SIGN_TEXT = "signText";
  private String signText;

  public static final String JSON_PROPERTY_SUBJECT = "subject";
  private Subject subject;

  public static final String JSON_PROPERTY_DEPENDS_ON_TASKS = "dependsOnTasks";
  private List<String> dependsOnTasks = null;


  public Task id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * A unique identifier for this task. The id must be specified by the client that creates the task. The id must be unique in the scope of the signing order. An id can only consist of characters A-Z, a-z, 0-9 and &#39;-&#39;,i.e. “A”, “1”, “Agreement”, “Task123456” etc. The task id will be used in URLs and must not contain sensitive information.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "b8a5ccdc-d79b-412e-a20e-03c2a8c8cdd2", value = "A unique identifier for this task. The id must be specified by the client that creates the task. The id must be unique in the scope of the signing order. An id can only consist of characters A-Z, a-z, 0-9 and '-',i.e. “A”, “1”, “Agreement”, “Task123456” etc. The task id will be used in URLs and must not contain sensitive information.")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public Task profile(String profile) {
    
    this.profile = profile;
    return this;
  }

   /**
   * The name of the graphical profile to use
   * @return profile
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "default", value = "The name of the graphical profile to use")
  @JsonProperty(JSON_PROPERTY_PROFILE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getProfile() {
    return profile;
  }


  public void setProfile(String profile) {
    this.profile = profile;
  }


  public Task language(String language) {
    
    this.language = language;
    return this;
  }

   /**
   * A two-letter language code. E.g.: en, nb, sv, fi, da
   * @return language
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "nb", value = "A two-letter language code. E.g.: en, nb, sv, fi, da")
  @JsonProperty(JSON_PROPERTY_LANGUAGE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getLanguage() {
    return language;
  }


  public void setLanguage(String language) {
    this.language = language;
  }


  public Task daysToLive(Integer daysToLive) {
    
    this.daysToLive = daysToLive;
    return this;
  }

   /**
   * The number of days from the task is created until the task times out. The end user will not be allowed to access or perform any operation on the task after this deadline.
   * minimum: 1
   * maximum: 30
   * @return daysToLive
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7", value = "The number of days from the task is created until the task times out. The end user will not be allowed to access or perform any operation on the task after this deadline.")
  @JsonProperty(JSON_PROPERTY_DAYS_TO_LIVE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getDaysToLive() {
    return daysToLive;
  }


  public void setDaysToLive(Integer daysToLive) {
    this.daysToLive = daysToLive;
  }


  public Task _configuration(String _configuration) {
    
    this._configuration = _configuration;
    return this;
  }

   /**
   * The name of a Responsive Signflow configuration
   * @return _configuration
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "pades", value = "The name of a Responsive Signflow configuration")
  @JsonProperty(JSON_PROPERTY_CONFIGURATION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getConfiguration() {
    return _configuration;
  }


  public void setConfiguration(String _configuration) {
    this._configuration = _configuration;
  }


  public Task documents(List<Document> documents) {
    
    this.documents = documents;
    return this;
  }

  public Task addDocumentsItem(Document documentsItem) {
    this.documents.add(documentsItem);
    return this;
  }

   /**
   * A list of the documents in the task
   * @return documents
  **/
  @ApiModelProperty(required = true, value = "A list of the documents in the task")
  @JsonProperty(JSON_PROPERTY_DOCUMENTS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public List<Document> getDocuments() {
    return documents;
  }


  public void setDocuments(List<Document> documents) {
    this.documents = documents;
  }


  public Task signatureMethods(List<Method> signatureMethods) {
    
    this.signatureMethods = signatureMethods;
    return this;
  }

  public Task addSignatureMethodsItem(Method signatureMethodsItem) {
    this.signatureMethods.add(signatureMethodsItem);
    return this;
  }

   /**
   * Specifies the eID signature methods that the end user may use to sign documents
   * @return signatureMethods
  **/
  @ApiModelProperty(required = true, value = "Specifies the eID signature methods that the end user may use to sign documents")
  @JsonProperty(JSON_PROPERTY_SIGNATURE_METHODS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public List<Method> getSignatureMethods() {
    return signatureMethods;
  }


  public void setSignatureMethods(List<Method> signatureMethods) {
    this.signatureMethods = signatureMethods;
  }


  public Task authentication(Authentication authentication) {
    
    this.authentication = authentication;
    return this;
  }

   /**
   * Get authentication
   * @return authentication
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_AUTHENTICATION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Authentication getAuthentication() {
    return authentication;
  }


  public void setAuthentication(Authentication authentication) {
    this.authentication = authentication;
  }


  public Task onTaskPostpone(String onTaskPostpone) {
    
    this.onTaskPostpone = onTaskPostpone;
    return this;
  }

   /**
   * The URL where the end user should be returned if they choose to postpone the task
   * @return onTaskPostpone
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://mydomain.com/postpone", value = "The URL where the end user should be returned if they choose to postpone the task")
  @JsonProperty(JSON_PROPERTY_ON_TASK_POSTPONE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOnTaskPostpone() {
    return onTaskPostpone;
  }


  public void setOnTaskPostpone(String onTaskPostpone) {
    this.onTaskPostpone = onTaskPostpone;
  }


  public Task onTaskComplete(String onTaskComplete) {
    
    this.onTaskComplete = onTaskComplete;
    return this;
  }

   /**
   * The URL where the end user should be returned when the task is completed
   * @return onTaskComplete
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://mydomain.com/complete", value = "The URL where the end user should be returned when the task is completed")
  @JsonProperty(JSON_PROPERTY_ON_TASK_COMPLETE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOnTaskComplete() {
    return onTaskComplete;
  }


  public void setOnTaskComplete(String onTaskComplete) {
    this.onTaskComplete = onTaskComplete;
  }


  public Task onTaskReject(String onTaskReject) {
    
    this.onTaskReject = onTaskReject;
    return this;
  }

   /**
   * The URL where the end user should be returned if the task is cancelled
   * @return onTaskReject
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://mydomain.com/reject", value = "The URL where the end user should be returned if the task is cancelled")
  @JsonProperty(JSON_PROPERTY_ON_TASK_REJECT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOnTaskReject() {
    return onTaskReject;
  }


  public void setOnTaskReject(String onTaskReject) {
    this.onTaskReject = onTaskReject;
  }


  public Task dialog(Dialog dialog) {
    
    this.dialog = dialog;
    return this;
  }

   /**
   * Get dialog
   * @return dialog
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_DIALOG)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Dialog getDialog() {
    return dialog;
  }


  public void setDialog(Dialog dialog) {
    this.dialog = dialog;
  }


  public Task notifications(List<TaskNotification> notifications) {
    
    this.notifications = notifications;
    return this;
  }

  public Task addNotificationsItem(TaskNotification notificationsItem) {
    if (this.notifications == null) {
      this.notifications = new ArrayList<>();
    }
    this.notifications.add(notificationsItem);
    return this;
  }

   /**
   * A list of notifications that should be sent out either when the task is created or later (as specified in the notification)
   * @return notifications
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "A list of notifications that should be sent out either when the task is created or later (as specified in the notification)")
  @JsonProperty(JSON_PROPERTY_NOTIFICATIONS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<TaskNotification> getNotifications() {
    return notifications;
  }


  public void setNotifications(List<TaskNotification> notifications) {
    this.notifications = notifications;
  }


  public Task signText(String signText) {
    
    this.signText = signText;
    return this;
  }

   /**
   * The text that will be displayed to the end user as part of the signing process and is intended to describe thedocuments, the context and other information about the documents. If configured this field will override the document-&gt;signTextEntry field
   * @return signText
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "The text that will be displayed to the end user as part of the signing process and is intended to describe thedocuments, the context and other information about the documents. If configured this field will override the document->signTextEntry field")
  @JsonProperty(JSON_PROPERTY_SIGN_TEXT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSignText() {
    return signText;
  }


  public void setSignText(String signText) {
    this.signText = signText;
  }


  public Task subject(Subject subject) {
    
    this.subject = subject;
    return this;
  }

   /**
   * Get subject
   * @return subject
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_SUBJECT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Subject getSubject() {
    return subject;
  }


  public void setSubject(Subject subject) {
    this.subject = subject;
  }


  public Task dependsOnTasks(List<String> dependsOnTasks) {
    
    this.dependsOnTasks = dependsOnTasks;
    return this;
  }

  public Task addDependsOnTasksItem(String dependsOnTasksItem) {
    if (this.dependsOnTasks == null) {
      this.dependsOnTasks = new ArrayList<>();
    }
    this.dependsOnTasks.add(dependsOnTasksItem);
    return this;
  }

   /**
   * A list of Task IDs from this Signing Order that this Task depends on. The current Task will not be started before all Tasks in this list are completed.
   * @return dependsOnTasks
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "A list of Task IDs from this Signing Order that this Task depends on. The current Task will not be started before all Tasks in this list are completed.")
  @JsonProperty(JSON_PROPERTY_DEPENDS_ON_TASKS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getDependsOnTasks() {
    return dependsOnTasks;
  }


  public void setDependsOnTasks(List<String> dependsOnTasks) {
    this.dependsOnTasks = dependsOnTasks;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Task task = (Task) o;
    return Objects.equals(this.id, task.id) &&
        Objects.equals(this.profile, task.profile) &&
        Objects.equals(this.language, task.language) &&
        Objects.equals(this.daysToLive, task.daysToLive) &&
        Objects.equals(this._configuration, task._configuration) &&
        Objects.equals(this.documents, task.documents) &&
        Objects.equals(this.signatureMethods, task.signatureMethods) &&
        Objects.equals(this.authentication, task.authentication) &&
        Objects.equals(this.onTaskPostpone, task.onTaskPostpone) &&
        Objects.equals(this.onTaskComplete, task.onTaskComplete) &&
        Objects.equals(this.onTaskReject, task.onTaskReject) &&
        Objects.equals(this.dialog, task.dialog) &&
        Objects.equals(this.notifications, task.notifications) &&
        Objects.equals(this.signText, task.signText) &&
        Objects.equals(this.subject, task.subject) &&
        Objects.equals(this.dependsOnTasks, task.dependsOnTasks);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, profile, language, daysToLive, _configuration, documents, signatureMethods, authentication, onTaskPostpone, onTaskComplete, onTaskReject, dialog, notifications, signText, subject, dependsOnTasks);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Task {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    profile: ").append(toIndentedString(profile)).append("\n");
    sb.append("    language: ").append(toIndentedString(language)).append("\n");
    sb.append("    daysToLive: ").append(toIndentedString(daysToLive)).append("\n");
    sb.append("    _configuration: ").append(toIndentedString(_configuration)).append("\n");
    sb.append("    documents: ").append(toIndentedString(documents)).append("\n");
    sb.append("    signatureMethods: ").append(toIndentedString(signatureMethods)).append("\n");
    sb.append("    authentication: ").append(toIndentedString(authentication)).append("\n");
    sb.append("    onTaskPostpone: ").append(toIndentedString(onTaskPostpone)).append("\n");
    sb.append("    onTaskComplete: ").append(toIndentedString(onTaskComplete)).append("\n");
    sb.append("    onTaskReject: ").append(toIndentedString(onTaskReject)).append("\n");
    sb.append("    dialog: ").append(toIndentedString(dialog)).append("\n");
    sb.append("    notifications: ").append(toIndentedString(notifications)).append("\n");
    sb.append("    signText: ").append(toIndentedString(signText)).append("\n");
    sb.append("    subject: ").append(toIndentedString(subject)).append("\n");
    sb.append("    dependsOnTasks: ").append(toIndentedString(dependsOnTasks)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

