/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.TaskSchedule;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The TaskNotification data type describes a notification to an end user or to a system about a task event in the system
 */
@ApiModel(description = "The TaskNotification data type describes a notification to an end user or to a system about a task event in the system")
@JsonPropertyOrder({
  TaskNotification.JSON_PROPERTY_ID,
  TaskNotification.JSON_PROPERTY_RECIPIENT,
  TaskNotification.JSON_PROPERTY_SENDER,
  TaskNotification.JSON_PROPERTY_HEADER,
  TaskNotification.JSON_PROPERTY_MESSAGE,
  TaskNotification.JSON_PROPERTY_TYPE,
  TaskNotification.JSON_PROPERTY_SCHEDULE
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class TaskNotification {
  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_RECIPIENT = "recipient";
  private String recipient;

  public static final String JSON_PROPERTY_SENDER = "sender";
  private String sender;

  public static final String JSON_PROPERTY_HEADER = "header";
  private String header;

  public static final String JSON_PROPERTY_MESSAGE = "message";
  private String message;

  /**
   * The notification type
   */
  public enum TypeEnum {
    SMS("SMS"),
    
    EMAIL("EMAIL"),
    
    URL("URL");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String value) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_TYPE = "type";
  private TypeEnum type;

  public static final String JSON_PROPERTY_SCHEDULE = "schedule";
  private List<TaskSchedule> schedule = null;


  public TaskNotification id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * A unique id for this notification in the scope of the signing order. The id must be created by the client when the notification is created.
   * @return id
  **/
  @ApiModelProperty(example = "c68c7fd4-600c-4e4c-964e-8e8d15a24e61", required = true, value = "A unique id for this notification in the scope of the signing order. The id must be created by the client when the notification is created.")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public TaskNotification recipient(String recipient) {
    
    this.recipient = recipient;
    return this;
  }

   /**
   * The address of the recipient of this notification
   * @return recipient
  **/
  @ApiModelProperty(example = "noreply@signicat.com", required = true, value = "The address of the recipient of this notification")
  @JsonProperty(JSON_PROPERTY_RECIPIENT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getRecipient() {
    return recipient;
  }


  public void setRecipient(String recipient) {
    this.recipient = recipient;
  }


  public TaskNotification sender(String sender) {
    
    this.sender = sender;
    return this;
  }

   /**
   * The address or name of the sender of this notification. Only relevant if the notification type is EMAIL or SMS.
   * @return sender
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "signicat", value = "The address or name of the sender of this notification. Only relevant if the notification type is EMAIL or SMS.")
  @JsonProperty(JSON_PROPERTY_SENDER)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSender() {
    return sender;
  }


  public void setSender(String sender) {
    this.sender = sender;
  }


  public TaskNotification header(String header) {
    
    this.header = header;
    return this;
  }

   /**
   * The header or subject text of the Message. Only relevant if the notification type is EMAIL.
   * @return header
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Task completed", value = "The header or subject text of the Message. Only relevant if the notification type is EMAIL.")
  @JsonProperty(JSON_PROPERTY_HEADER)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getHeader() {
    return header;
  }


  public void setHeader(String header) {
    this.header = header;
  }


  public TaskNotification message(String message) {
    
    this.message = message;
    return this;
  }

   /**
   * The message text in the notification. Formatting is not supported in notification messages. [Supports placeholders.](https://developer.signicat.com/apis/sign-api/sign-api-v1/#IntegrationDetails)
   * @return message
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "A task belonging to the signing order with ID ${orderId} has been completed.", value = "The message text in the notification. Formatting is not supported in notification messages. [Supports placeholders.](https://developer.signicat.com/apis/sign-api/sign-api-v1/#IntegrationDetails)")
  @JsonProperty(JSON_PROPERTY_MESSAGE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getMessage() {
    return message;
  }


  public void setMessage(String message) {
    this.message = message;
  }


  public TaskNotification type(TypeEnum type) {
    
    this.type = type;
    return this;
  }

   /**
   * The notification type
   * @return type
  **/
  @ApiModelProperty(example = "EMAIL", required = true, value = "The notification type")
  @JsonProperty(JSON_PROPERTY_TYPE)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public TypeEnum getType() {
    return type;
  }


  public void setType(TypeEnum type) {
    this.type = type;
  }


  public TaskNotification schedule(List<TaskSchedule> schedule) {
    
    this.schedule = schedule;
    return this;
  }

  public TaskNotification addScheduleItem(TaskSchedule scheduleItem) {
    if (this.schedule == null) {
      this.schedule = new ArrayList<>();
    }
    this.schedule.add(scheduleItem);
    return this;
  }

   /**
   * A list of TaskSchedule objects. See the data type for TaskSchedule.If this field is missing, the notification will be sent once the task is created.
   * @return schedule
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "A list of TaskSchedule objects. See the data type for TaskSchedule.If this field is missing, the notification will be sent once the task is created.")
  @JsonProperty(JSON_PROPERTY_SCHEDULE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<TaskSchedule> getSchedule() {
    return schedule;
  }


  public void setSchedule(List<TaskSchedule> schedule) {
    this.schedule = schedule;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TaskNotification taskNotification = (TaskNotification) o;
    return Objects.equals(this.id, taskNotification.id) &&
        Objects.equals(this.recipient, taskNotification.recipient) &&
        Objects.equals(this.sender, taskNotification.sender) &&
        Objects.equals(this.header, taskNotification.header) &&
        Objects.equals(this.message, taskNotification.message) &&
        Objects.equals(this.type, taskNotification.type) &&
        Objects.equals(this.schedule, taskNotification.schedule);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, recipient, sender, header, message, type, schedule);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TaskNotification {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    recipient: ").append(toIndentedString(recipient)).append("\n");
    sb.append("    sender: ").append(toIndentedString(sender)).append("\n");
    sb.append("    header: ").append(toIndentedString(header)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    schedule: ").append(toIndentedString(schedule)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

