/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The Task Schedule Delay data type describes the delay before sending a notification after it has entered its scheduled state defined by triggerStatus. The total delay is &#x3D; days + hours + minutes.
 */
@ApiModel(description = "The Task Schedule Delay data type describes the delay before sending a notification after it has entered its scheduled state defined by triggerStatus. The total delay is = days + hours + minutes.")
@JsonPropertyOrder({
  TaskScheduleDelay.JSON_PROPERTY_MINUTES,
  TaskScheduleDelay.JSON_PROPERTY_HOURS,
  TaskScheduleDelay.JSON_PROPERTY_DAYS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class TaskScheduleDelay {
  public static final String JSON_PROPERTY_MINUTES = "minutes";
  private Integer minutes;

  public static final String JSON_PROPERTY_HOURS = "hours";
  private Integer hours;

  public static final String JSON_PROPERTY_DAYS = "days";
  private Integer days;


  public TaskScheduleDelay minutes(Integer minutes) {
    
    this.minutes = minutes;
    return this;
  }

   /**
   * The number of minutes this notification is delayed when the triggerStatus condition is met. When the signing order gets deleted this notification will become obsolete
   * minimum: 1
   * maximum: 59
   * @return minutes
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "30", value = "The number of minutes this notification is delayed when the triggerStatus condition is met. When the signing order gets deleted this notification will become obsolete")
  @JsonProperty(JSON_PROPERTY_MINUTES)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getMinutes() {
    return minutes;
  }


  public void setMinutes(Integer minutes) {
    this.minutes = minutes;
  }


  public TaskScheduleDelay hours(Integer hours) {
    
    this.hours = hours;
    return this;
  }

   /**
   * The number of hours this notification is delayed when the triggerStatus condition is met. When the signing order gets deleted this notification will become obsolete
   * minimum: 1
   * maximum: 23
   * @return hours
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "12", value = "The number of hours this notification is delayed when the triggerStatus condition is met. When the signing order gets deleted this notification will become obsolete")
  @JsonProperty(JSON_PROPERTY_HOURS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getHours() {
    return hours;
  }


  public void setHours(Integer hours) {
    this.hours = hours;
  }


  public TaskScheduleDelay days(Integer days) {
    
    this.days = days;
    return this;
  }

   /**
   * The number of days this notification is delayed when the triggerStatus condition is metWhen the signing order gets deleted this notification will become obsolete
   * minimum: 1
   * @return days
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7", value = "The number of days this notification is delayed when the triggerStatus condition is metWhen the signing order gets deleted this notification will become obsolete")
  @JsonProperty(JSON_PROPERTY_DAYS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getDays() {
    return days;
  }


  public void setDays(Integer days) {
    this.days = days;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TaskScheduleDelay taskScheduleDelay = (TaskScheduleDelay) o;
    return Objects.equals(this.minutes, taskScheduleDelay.minutes) &&
        Objects.equals(this.hours, taskScheduleDelay.hours) &&
        Objects.equals(this.days, taskScheduleDelay.days);
  }

  @Override
  public int hashCode() {
    return Objects.hash(minutes, hours, days);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TaskScheduleDelay {\n");
    sb.append("    minutes: ").append(toIndentedString(minutes)).append("\n");
    sb.append("    hours: ").append(toIndentedString(hours)).append("\n");
    sb.append("    days: ").append(toIndentedString(days)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

