/*
 * Signicat Sign REST API
 * Signicat's signature rest microservice
 *
 * The version of the OpenAPI document: v1
 * Contact: support@signicat.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.example.demo.signapi.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.example.demo.signapi.client.model.DocumentStatus;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

/**
 * The TaskStatusInfo data type describes the status for a specific task
 */
@ApiModel(description = "The TaskStatusInfo data type describes the status for a specific task")
@JsonPropertyOrder({
  TaskStatusInfo.JSON_PROPERTY_ORDER_ID,
  TaskStatusInfo.JSON_PROPERTY_TASK_ID,
  TaskStatusInfo.JSON_PROPERTY_TASK_STATUS,
  TaskStatusInfo.JSON_PROPERTY_CLIENT_REFERENCE,
  TaskStatusInfo.JSON_PROPERTY_CLIENT_STATUS,
  TaskStatusInfo.JSON_PROPERTY_DOCUMENTS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-08-07T12:23:12.790+02:00[Europe/Oslo]")
public class TaskStatusInfo {
  public static final String JSON_PROPERTY_ORDER_ID = "orderId";
  private String orderId;

  public static final String JSON_PROPERTY_TASK_ID = "taskId";
  private String taskId;

  /**
   * The status for this task
   */
  public enum TaskStatusEnum {
    CREATED("CREATED"),
    
    COMPLETED("COMPLETED"),
    
    REJECTED("REJECTED"),
    
    EXPIRED("EXPIRED"),
    
    DELETED("DELETED");

    private String value;

    TaskStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TaskStatusEnum fromValue(String value) {
      for (TaskStatusEnum b : TaskStatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_TASK_STATUS = "taskStatus";
  private TaskStatusEnum taskStatus;

  public static final String JSON_PROPERTY_CLIENT_REFERENCE = "clientReference";
  private String clientReference;

  public static final String JSON_PROPERTY_CLIENT_STATUS = "clientStatus";
  private String clientStatus;

  public static final String JSON_PROPERTY_DOCUMENTS = "documents";
  private List<DocumentStatus> documents = null;


  public TaskStatusInfo orderId(String orderId) {
    
    this.orderId = orderId;
    return this;
  }

   /**
   * The unique identifier of the signing order
   * @return orderId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "05022019298twl5n4wo4soavolfwnxev9rxfghqapyk8junju1wxqamkeq", value = "The unique identifier of the signing order")
  @JsonProperty(JSON_PROPERTY_ORDER_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOrderId() {
    return orderId;
  }


  public void setOrderId(String orderId) {
    this.orderId = orderId;
  }


  public TaskStatusInfo taskId(String taskId) {
    
    this.taskId = taskId;
    return this;
  }

   /**
   * The unique identifier of the task (is omitted if task status is “deleted”)
   * @return taskId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "537c8bf6-9b02-49d7-97d1-8d7ad2be36bf", value = "The unique identifier of the task (is omitted if task status is “deleted”)")
  @JsonProperty(JSON_PROPERTY_TASK_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getTaskId() {
    return taskId;
  }


  public void setTaskId(String taskId) {
    this.taskId = taskId;
  }


  public TaskStatusInfo taskStatus(TaskStatusEnum taskStatus) {
    
    this.taskStatus = taskStatus;
    return this;
  }

   /**
   * The status for this task
   * @return taskStatus
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "COMPLETED", value = "The status for this task")
  @JsonProperty(JSON_PROPERTY_TASK_STATUS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public TaskStatusEnum getTaskStatus() {
    return taskStatus;
  }


  public void setTaskStatus(TaskStatusEnum taskStatus) {
    this.taskStatus = taskStatus;
  }


  public TaskStatusInfo clientReference(String clientReference) {
    
    this.clientReference = clientReference;
    return this;
  }

   /**
   * The client reference that was registered with this task, if any
   * @return clientReference
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "d8e75ef7-6b3c-4511-b2ee-2b419a0c5cea", value = "The client reference that was registered with this task, if any")
  @JsonProperty(JSON_PROPERTY_CLIENT_REFERENCE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getClientReference() {
    return clientReference;
  }


  public void setClientReference(String clientReference) {
    this.clientReference = clientReference;
  }


  public TaskStatusInfo clientStatus(String clientStatus) {
    
    this.clientStatus = clientStatus;
    return this;
  }

   /**
   * The last client status that was registered on this task, if any
   * @return clientStatus
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "fbcf52a7-a952-41fc-82d9-beefbe094f6f", value = "The last client status that was registered on this task, if any")
  @JsonProperty(JSON_PROPERTY_CLIENT_STATUS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getClientStatus() {
    return clientStatus;
  }


  public void setClientStatus(String clientStatus) {
    this.clientStatus = clientStatus;
  }


  public TaskStatusInfo documents(List<DocumentStatus> documents) {
    
    this.documents = documents;
    return this;
  }

  public TaskStatusInfo addDocumentsItem(DocumentStatus documentsItem) {
    if (this.documents == null) {
      this.documents = new ArrayList<>();
    }
    this.documents.add(documentsItem);
    return this;
  }

   /**
   * A list with status info for each of the documents in the task, provided the task status is COMPLETED
   * @return documents
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "A list with status info for each of the documents in the task, provided the task status is COMPLETED")
  @JsonProperty(JSON_PROPERTY_DOCUMENTS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<DocumentStatus> getDocuments() {
    return documents;
  }


  public void setDocuments(List<DocumentStatus> documents) {
    this.documents = documents;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TaskStatusInfo taskStatusInfo = (TaskStatusInfo) o;
    return Objects.equals(this.orderId, taskStatusInfo.orderId) &&
        Objects.equals(this.taskId, taskStatusInfo.taskId) &&
        Objects.equals(this.taskStatus, taskStatusInfo.taskStatus) &&
        Objects.equals(this.clientReference, taskStatusInfo.clientReference) &&
        Objects.equals(this.clientStatus, taskStatusInfo.clientStatus) &&
        Objects.equals(this.documents, taskStatusInfo.documents);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orderId, taskId, taskStatus, clientReference, clientStatus, documents);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TaskStatusInfo {\n");
    sb.append("    orderId: ").append(toIndentedString(orderId)).append("\n");
    sb.append("    taskId: ").append(toIndentedString(taskId)).append("\n");
    sb.append("    taskStatus: ").append(toIndentedString(taskStatus)).append("\n");
    sb.append("    clientReference: ").append(toIndentedString(clientReference)).append("\n");
    sb.append("    clientStatus: ").append(toIndentedString(clientStatus)).append("\n");
    sb.append("    documents: ").append(toIndentedString(documents)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

